#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "GS.h"


Block blockTable32[] = {
	{  0,  0,  0 }, {  1,  8,  0 }, {  4,  0,  8 }, {  5,  8,  8 }, { 16, 16,  0 }, { 17, 24,  0 }, { 20, 16,  8 }, { 21, 24,  8 }, 
	{  2,  0, 16 }, {  3,  8, 16 }, {  6,  0, 24 }, {  7,  8, 24 }, { 18, 16, 16 }, { 19, 24, 16 }, { 22, 16, 24 }, { 23, 24, 24 }, 
	{  8, 32,  0 }, {  9, 40,  0 }, { 12, 32,  8 }, { 13, 40,  8 }, { 24, 48,  0 }, { 25, 56,  0 }, { 28, 48,  8 }, { 29, 56,  8 }, 
	{ 10, 32, 16 }, { 11, 40, 16 }, { 14, 32, 24 }, { 15, 40, 24 }, { 26, 48, 16 }, { 27, 56, 16 }, { 30, 48, 24 }, { 31, 56, 24 },
};

Block blockTable16[] = {
	{  0,  0,  0 }, {  2,  0,  8 }, {  8, 16,  0 }, { 10, 16,  8 },
	{  1,  0, 16 }, {  3,  0, 24 }, {  9, 16, 16 }, { 11, 16, 24 }, 
	{  4, 32,  0 }, {  6, 32,  8 }, { 12, 48,  0 }, { 14, 48,  8 },
	{  5, 32, 16 }, {  7, 32, 24 }, { 13, 48, 16 }, { 15, 48, 24 }, 
	{ 16,  0, 32 }, { 18,  0, 40 }, { 24, 16, 32 }, { 26, 16, 40 },
	{ 17,  0, 48 }, { 19,  0, 56 }, { 25, 16, 48 }, { 27, 16, 56 }, 
	{ 20, 32, 32 }, { 22, 32, 40 }, { 28, 48, 32 }, { 30, 48, 40 },
	{ 21, 32, 48 }, { 23, 32, 56 }, { 29, 48, 48 }, { 31, 48, 56 }, 
};

Block blockTable16S[] = {
	{  0,  0,  0 }, {  2,  0,  8 }, { 16, 16,  0 }, { 18, 16,  8 },
	{  1,  0, 32 }, {  3,  0, 40 }, { 17, 16, 32 }, { 19, 16, 40 }, 
	{  8,  0, 16 }, { 10,  0, 24 }, { 24, 16, 16 }, { 26, 16, 24 },
	{  9,  0, 48 }, { 11,  0, 56 }, { 25, 16, 48 }, { 27, 16, 56 }, 
	{  4, 32,  0 }, {  6, 32,  8 }, { 20, 48,  0 }, { 22, 48,  8 },
	{  5, 32, 32 }, {  7, 32, 40 }, { 21, 48, 32 }, { 23, 48, 40 }, 
	{ 12, 32, 16 }, { 14, 32, 24 }, { 28, 48, 16 }, { 30, 48, 24 },
	{ 13, 32, 48 }, { 15, 32, 56 }, { 29, 48, 48 }, { 31, 48, 56 }, 
};

Block blockTable8[] = {
	{  0,   0,  0 }, {  1,  16,  0 }, {  4,   0, 16 }, {  5,  16, 16 }, { 16,  32,  0 }, { 17,  48,  0 }, { 20,  32, 16 }, { 21,  48, 16 }, 
	{  2,   0, 32 }, {  3,  16, 32 }, {  6,   0, 48 }, {  7,  16, 48 },	{ 18,  32, 32 }, { 19,  48, 32 }, { 22,  32, 48 }, { 23,  48, 48 }, 
	{  8,  64,  0 }, {  9,  80,  0 }, { 12,  64, 16 }, { 13,  80, 16 },	{ 24,  96,  0 }, { 25, 112,  0 }, { 28,  96, 16 }, { 29, 112, 16 }, 
	{ 10,  64, 32 }, { 11,  80, 32 }, { 14,  64, 48 }, { 15,  80, 48 },	{ 26,  96, 32 }, { 27, 112, 32 }, { 30,  96, 48 }, { 31, 112, 48 },
};

Block blockTable4[] = {
	{  0,  0,   0 }, {  2,  0,  16 }, {  8, 32,   0 }, { 10, 32,  16 },
	{  1,  0,  32 }, {  3,  0,  48 }, {  9, 32,  32 }, { 11, 32,  48 }, 
	{  4, 64,   0 }, {  6, 64,  16 }, { 12, 96,   0 }, { 14, 96,  16 },
	{  5, 64,  32 }, {  7, 64,  48 }, { 13, 96,  32 }, { 15, 96,  48 }, 
	{ 16,  0,  64 }, { 18,  0,  80 }, { 24, 32,  64 }, { 26, 32,  80 },
	{ 17,  0,  96 }, { 19,  0, 112 }, { 25, 32,  96 }, { 27, 32, 112 }, 
	{ 20, 64,  64 }, { 22, 64,  80 }, { 28, 96,  64 }, { 30, 96,  80 },
	{ 21, 64,  96 }, { 23, 64, 112 }, { 29, 96,  96 }, { 31, 96, 112 }, 
};

u32 getPageAddress32(u32 bp, u32 bw) {
	int px, py;

	px = (bp % ((bw+63)/64)) * 64;
	py = (bp / ((bw+63)/64)) * 32;
	return py * bw + px;
}

u32 getPageAddress8(u32 bp, u32 bw) {
	int px, py;

	px = (bp % ((bw+127)/128)) * 128;
	py = (bp / ((bw+127)/128)) * 64;
	return py * bw + px;
}

u32 getPageAddress4(u32 bp, u32 bw) {
	int px, py;

	px = (bp % ((bw+127)/128)) * 128;
	py = (bp / ((bw+127)/128)) * 128;
	return py * bw + px;
}

u32 getPixelAddress32(int x, int y, u32 bp, u32 bw) {
	u32 page;
	u32 word;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable32[((x >> 3) & 0x7) + ((y >> 3) & 0x3) * 8].n;
	dx = blockTable32[i & 0x1f].x + (x & 0x07);
	dy = blockTable32[i & 0x1f].y + (y & 0x07);

	page = (bp >> 5) + (i >> 5) + ((y / 32) * (bw/64)) + x/64;
	page = getPageAddress32(page, bw);
	word = page + (dy * bw + dx);
//	GS_LOG("getPixelAddress: %d, %d -> %d, %d (i=%d) (bp=%x\n", x, y, dx, dy, i, bp);
	
	return word;
}

u32 getPixelAddress16(int x, int y, u32 bp, u32 bw) {
	u16 *buf;
	int dx, dy;
	int i;

	return 0;
/*	i = (bp & 0x1f) + blockTable16[((x >> 4) & 0x3) + ((y >> 3) & 0x7) * 4].n;
	dx = blockTable16[i & 0x1f].x + (x & ~0x30);
	dy = blockTable16[i & 0x1f].y + (y & ~0x38);

	dx+= ((i >> 5) % (bw/64)) * 64;
	dy+= ((i >> 5) / (bw/64)) * 64;

	buf = (u16*)getPageAddress(bp, bw);
//	GS_LOG("getPixelAddress16: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	return &buf[dy * bw + dx];*/
}

u32 getPixelAddress16S(int x, int y, u32 bp, u32 bw) {
	u16 *buf;
	int dx, dy;
	int i;

	return 0;
/*	i = (bp & 0x1f) + blockTable16S[((x >> 4) & 0x3) + ((y >> 3) & 0x7) * 4].n;
	dx = blockTable16S[i & 0x1f].x + (x & ~0x30);
	dy = blockTable16S[i & 0x1f].y + (y & ~0x38);

	dx+= ((i >> 5) % (bw/64)) * 64;
	dy+= ((i >> 5) / (bw/64)) * 64;

	buf = (u16*)getPageAddress(bp, bw);
//	GS_LOG("getPixelAddress16: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	return &buf[dy * bw + dx];*/
}

u32 getPixelAddress8(int x, int y, u32 bp, u32 bw) {
	u32 page;
	u32 word;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable8[((x >> 4) & 0x7) + ((y >> 4) & 0x3) * 8].n;
	dx = blockTable8[i & 0x1f].x + (x & 0x0f);
	dy = blockTable8[i & 0x1f].y + (y & 0x0f);

	page = (bp >> 5) + (i >> 5) + ((y / 64) * (bw/128)) + x/128;
	page = getPageAddress8(page, bw);
	word = page + (dy * bw + dx);
//	GS_LOG("getPixelAddress: %d, %d -> %d, %d (i=%d) (bp=%x\n", x, y, dx, dy, i, bp);
	
	return word;
/*	u8  *buf;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable8[((x >> 4) & 0x7) + ((y >> 4) & 0x3) * 8].n;
	dx = blockTable8[i & 0x1f].x + (x & ~0x70);
	dy = blockTable8[i & 0x1f].y + (y & ~0x30);

//	dx+= ((i >> 5) % (bw/128)) * 128;
//	dy+= ((i >> 5) / (bw/128)) * 64;

//	GS_LOG("getPixelAddress8: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	buf = (u8*)getPageAddress(bp+i, bw);
	return &buf[dy * bw + dx];*/
}

u32 getPixelAddress4(int x, int y, u32 bp, u32 bw) {
	u32 page;
	u32 word;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable4[((x >> 5) & 0x3) + ((y >> 4) & 0x7) * 4].n;
	dx = blockTable4[i & 0x1f].x + (x & 0x1f);
	dy = blockTable4[i & 0x1f].y + (y & 0x0f);

	page = (bp >> 5) + (i >> 5) + ((y / 128) * (bw/128)) + x/128;
	page = getPageAddress4(page, bw);
	word = page + (dy * bw + dx);
//	GS_LOG("getPixelAddress: %d, %d -> %d, %d (i=%d) (bp=%x\n", x, y, dx, dy, i, bp);
	
	return word;
/*	u8  *buf;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable4[((x >> 5) & 0x3) + ((y >> 4) & 0x7) * 4].n;
	dx = blockTable4[i & 0x1f].x + (x & ~0x60);
	dy = blockTable4[i & 0x1f].y + (y & ~0x70);

//	dx+= ((i >> 5) % (bw/128)) * 128;
//	dy+= ((i >> 5) / (bw/128)) * 128;

//	GS_LOG("getPixelAddress4: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	buf = (u8*)getPageAddress(bp+i, bw/2);
	return &buf[dy * (bw/2) + dx/2];*/
}

u32 getPixelAddress32Z(int x, int y, u32 bp, u32 bw) {
	u32 page;
	u32 word;
	int dx, dy;
	int i;

	i = (bp & 0x1f) + blockTable32[((x >> 3) & 0x7) + ((y >> 3) & 0x3) * 8].n;
	dx = blockTable32[i & 0x1f].x + (x & 0x07);
	dy = blockTable32[i & 0x1f].y + (y & 0x07);

	page = (bp >> 5) + (i >> 5) + ((y / 32) * (bw/64)) + x/64;
	page = getPageAddress32(page, bw);
	word = page + (dy * bw + dx);
//	GS_LOG("getPixelAddress: %d, %d -> %d, %d (i=%d) (bp=%x\n", x, y, dx, dy, i, bp);
	
	return word;
}

u32 getPixelAddress16Z(int x, int y, u32 bp, u32 bw) {
	u16 *buf;
	int dx, dy;
	int i;

	return 0;
/*	i = (bp & 0x1f) + blockTable16[((x >> 4) & 0x3) + ((y >> 3) & 0x7) * 4].n;
	dx = blockTable16[i & 0x1f].x + (x & ~0x30);
	dy = blockTable16[i & 0x1f].y + (y & ~0x38);

	dx+= ((i >> 5) % (bw/64)) * 64;
	dy+= ((i >> 5) / (bw/64)) * 64;

	buf = (u16*)getPageAddress(bp, bw);
//	GS_LOG("getPixelAddress16: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	return &buf[dy * bw + dx];*/
}

u32 getPixelAddress16SZ(int x, int y, u32 bp, u32 bw) {
	u32 page;
	u32 word;
	int dx, dy;
	int i;

	return 0;
/*	i = (bp & 0x1f) + blockTable16S[((x >> 4) & 0x3) + ((y >> 3) & 0x7) * 4].n;
	dx = blockTable16S[i & 0x1f].x + (x & ~0x30);
	dy = blockTable16S[i & 0x1f].y + (y & ~0x38);

	dx+= ((i >> 5) % (bw/64)) * 64;
	dy+= ((i >> 5) / (bw/64)) * 64;

	page = getPageAddress(bp, bw);
	word = page + dy * bw + dx;
//	GS_LOG("getPixelAddress16: %d, %d -> %d, %d (i=%d)\n", x, y, dx, dy, i);
	return word;*/
}

