#include <string.h>
#include <gtk/gtk.h>

#include "PAD.h"
#include "interface.h"
#include "support.h"

Display *GSdsp;
XEvent E;

static void _PADupdate() {
	int key;

    while (XPending(GSdsp)) {
		XNextEvent(GSdsp, &E);
		switch (E.type) {
	    	case KeyPress:
				key = XLookupKeysym((XKeyEvent *)&E, 0);
				_KeyPress(key);
				break;

		    case KeyRelease:
				key = XLookupKeysym((XKeyEvent *)&E, 0);
				_KeyRelease(key);
				break;

	    	case FocusIn:
				XAutoRepeatOff(GSdsp);
				break;

	    	case FocusOut:
				XAutoRepeatOn(GSdsp);
				break;
		}
    }
}

static s32  _PADopen(void *pDsp) {
	GSdsp = (Display*)*(long*)pDsp;
    XAutoRepeatOff(GSdsp);

	return 0;
}

static void _PADclose() {
    XAutoRepeatOn(GSdsp);
}


GtkWidget *Conf;
GtkWidget *Btn;
//GtkWidget *Analog;
char name[32];

int padn;

void UpdateConf() {
	int i;

	for (i=0; i<24; i++) {
	    char *tmp;

		sprintf(name, "Key%d", i);
		Btn = lookup_widget(Conf, name);
	   	tmp = XKeysymToString(conf.keys[padn][i]);
		if (tmp != NULL)
			gtk_label_set_text(GTK_LABEL(GTK_BIN(Btn)->child), tmp);
		else
			gtk_label_set_text(GTK_LABEL(GTK_BIN(Btn)->child), "Unknown");
		gtk_object_set_user_data(GTK_OBJECT(Btn), &conf.keys[padn][i]);
	}
}

void OnConf_Key(GtkButton *Btn) {
    GdkEvent *ev;
	unsigned long *key = (unsigned long*)gtk_object_get_user_data(GTK_OBJECT(Btn));
    char *tmp;

    for (;;) {
		ev = gdk_event_get();
		if (ev != NULL) {
	    	if (ev->type == GDK_KEY_PRESS) {
    		    *key = ev->key.keyval;
		    	tmp = XKeysymToString(*key);
		    	if (tmp != NULL)
					gtk_label_set_text(GTK_LABEL(GTK_BIN(Btn)->child), tmp);
			    else
					gtk_label_set_text(GTK_LABEL(GTK_BIN(Btn)->child), "Unknown");
				return;
			}
	    }
    }
}

void OnConf_Pad1() {
	padn = 0;
	UpdateConf();
}

void OnConf_Pad2() {
	padn = 1;
	UpdateConf();
}

void OnConf_Ok() {
//	conf.analog = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(Analog));

	SaveConfig();

	gtk_widget_destroy(Conf);
	gtk_main_quit();
}

void OnConf_Cancel() {
	gtk_widget_destroy(Conf);
	gtk_main_quit();
}

void CALLBACK PADconfigure() {
	LoadConfig();

	Conf = create_Config();

//	Analog = lookup_widget(Conf, "GtkCheckButton_Analog");
//	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(Analog), conf.analog);

	padn = 0;
	UpdateConf();

	gtk_widget_show_all(Conf);	
	gtk_main();
}

GtkWidget *About;

void OnAbout_Ok() {
	gtk_widget_destroy(About);
	gtk_main_quit();
}

void CALLBACK PADabout() {

	About = create_About();

	gtk_widget_show_all(About);
	gtk_main();
}

s32 CALLBACK PADtest() {
	return 0;
}
/*
PADdriver PADx11 = {
	"x11",
	_PADopen,
	_PADclose,
	_PADupdate,
};
*/